package com.insomnia.parser;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Saver {
    private static final String appName = "Insomnia";
    private static int os = 0;

    public static String getDirApp(){
        return System.getProperty("user.dir");
    }

    public static String getOutputDir(){
        File f = new File(getDirApp(),"Outputs");
        f.mkdir();
        return f.toString();
    }

    public static String getRequestsDir(){
        if (os == 0) {
            String s = System.getProperty("os.name", "").toLowerCase();
            os = s.contains("win") ? 1 : 2;
        }
        if (os == 1) {
            File res = new File(System.getenv("AppData"), appName);
            res.mkdir();
            return res.toString();
        }

        File f = new File(getDirApp(),"Requests");
        f.mkdir();
        return f.toString();
    }

    /**
     * @return saved file name or empty if file didn't save
     */
    public static String saveRequest (RequestData data) {
        int size = new File(getRequestsDir()).list().length + 1;
        String fileName = "Request "+size+".insomnia";
        File file = new File(getRequestsDir(),fileName);
        boolean fileFound = file.exists();
        if (fileFound) {
            while (fileFound) {
                size++;
                fileName = "Request "+size+".insomnia";
                file = new File(getRequestsDir(),fileName);
                fileFound = file.exists();
            }
        }

        try {
            file.createNewFile();
            FileOutputStream fo = new FileOutputStream(file);
            ObjectOutputStream out = new ObjectOutputStream(fo);
            out.writeObject(data);
            out.close();
            fo.close();

            return fileName;
        } catch (IOException e) {
            e.printStackTrace();

            return "";
        }
    }

    public static RequestData readRequest (String fileName){
        try {
            FileInputStream file = new FileInputStream(new File(getRequestsDir(),fileName));
            ObjectInputStream in = new ObjectInputStream(file);

            RequestData data = (RequestData) in.readObject();

            in.close();
            file.close();
            return  data;
        } catch(IOException | ClassNotFoundException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static File[] getRequestFiles(){
        return new File(getRequestsDir()).listFiles();
    }

}
